//
//  BWDisk.h
//  UberProject
//
//  Created by Brian Webster on Fri Jul 23 2004.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <sys/mount.h>

@interface BWDisk : NSObject 
{
	NSString*			devicePath;
	NSString*			mountPath;
	BOOL				isWritable;
	NSString*			volumeName;
	BOOL				isRemovable;
	NSDate*				creationDate;
	NSDate*				modificationDate;
	BOOL				isMounted;
	BOOL				getAttrInfoCached;
}

+ (NSArray*)mountedDisks;
+ (BWDisk*)diskForMountPath:(NSString*)path;

- (id)initWithStat:(struct statfs*)diskInfo;

- (void)getAttrInfo;
- (NSString*)devicePath;
- (NSString*)mountPath;
- (NSImage*)icon;
- (BOOL)isWritable;
- (NSString*)volumeName;
- (BOOL)isRemovable;
- (NSDate*)creationDate;
- (NSDate*)modificationDate;
- (BOOL)isMounted;

@end
