//
//  BWFavoritesList.h
//  UberProject
//
//  Created by Brian Webster on Sat May 01 2004.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class BWPathIndexer, BWFavorite;

@interface BWFavoritesList : NSObject 
{
	NSMutableArray*			favoritePaths;
	NSMutableDictionary*	favorites;
	IBOutlet NSMenuItem*	favoritesMenuItem;
	BWPathIndexer*			pathIndexer;
	unsigned				suspendRebuildCount;
}

+ (BWFavoritesList*)sharedFavoritesList;
- (unsigned)numFavorites;
- (BWFavorite*)favoriteAtIndex:(unsigned)index;
- (BWFavorite*)favoriteWithPath:(NSString*)path;
- (NSArray*)allFavorites;
- (BWFavorite*)addFavoriteWithPath:(NSString*)path;
- (void)addFavorite:(BWFavorite*)newFavorite;
- (void)removeFavoriteWithPath:(NSString*)path;
- (void)removeFavoriteAtIndex:(unsigned)index;
- (void)rebuildFavoritesMenu;
- (void)suspendRebuilds;
- (void)resumeRebulids;
- (void)saveFavoritesToDefaults;
- (void)loadFavoritesFromDefaults;

@end

extern NSString* BWFavoritesListDidAddFavoriteNotification;
extern NSString* BWFavoritesListDidRemoveFavoriteNotification;
