//
//  BWProgressController.h
//  UberProject
//
//  Created by Brian Webster on Fri Apr 04 2003.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//
//	BWProgressController is used to display a window or sheet that displays progress
//	information about a long operation.  You can use BWProgressController with a
//	BWThreadedTask and it will use bindings to automatically update its display as
//	the task updates its progress fields.

#import <Cocoa/Cocoa.h>
#import <BWFoundation/BWFoundation.h>

@interface BWProgressController : NSWindowController 
{
	IBOutlet NSProgressIndicator*	progressIndicator;
	IBOutlet NSTextField*			progressMessageTextField;
	IBOutlet NSTextField*			secondaryMessageTextField;
	IBOutlet NSButton*				cancelButton;
	NSWindow*						parentWindow;
#if MAC_OS_X_VERSION_MIN_REQUIRED >= MAC_OS_X_VERSION_10_3
	BWThreadedTask*					task;
#endif
}

- (id)init;

#if MAC_OS_X_VERSION_MIN_REQUIRED >= MAC_OS_X_VERSION_10_3
- (BWThreadedTask*)task;
- (void)setTask:(BWThreadedTask*)newTask;
#endif

- (void)setMaxValue:(double)newValue;
- (void)setMinValue:(double)newValue;
- (void)setIndeterminate:(BOOL)newValue;
- (void)setProgressMessage:(NSString*)message;
- (void)setCancelButtonEnabled:(BOOL)enabled;
- (void)setSecondaryMessage:(NSString*)message;
- (void)setParentWindow:(NSWindow*)window;
- (void)beginProgress;
- (void)beginProgressWithWindow:(NSWindow*)window;
- (void)endProgress;

@end
