/* BWRegistrationManager */

#import <Cocoa/Cocoa.h>

@interface BWRegistrationManager : NSObject
{
    IBOutlet NSTextField*		companyTextField;
    IBOutlet NSTextField*		messageTextField;
    IBOutlet NSTextField*		nameTextField;
    IBOutlet NSButton*			purchaseButton;
    IBOutlet NSButton*			registerButton;
    IBOutlet NSTextField*		registrationTextField;
    IBOutlet NSWindow*			registrationWindow;
	IBOutlet NSButton*			cancelButton;
	NSDictionary*				registrationInfo;
	id							delegate;
	BOOL						currentInfoIsValid;
	BOOL						isSheet;
	BOOL						spotlightCheckEnabled;
	NSMetadataQuery*			registrationQuery;
	NSString*					spotlightContentString;
}

+ (BWRegistrationManager*)defaultManager;

- (IBAction)enterRegistration:(id)sender;
- (IBAction)purchase:(id)sender;

- (BOOL)currentInfoIsValid;

- (NSDictionary*)registrationInfo;
- (void)setRegistrationInfo:(NSDictionary*)newRegistrationInfo;

- (id)delegate;
- (void)setDelegate:(id)newDelegate;

- (BOOL)spotlightCheckEnabled;
- (void)setSpotlightCheckEnabled:(BOOL)newSpotlightCheckEnabled;
- (NSString*)spotlightContentString;
- (void)setSpotlightContentString:(NSString*)newSpotlightContentString;

- (void)showRegistrationPanel;
- (void)showRegistrationPanelModalForWindow:(NSWindow*)inWindow;

@end

extern NSString*		BWRegistrationNameKey;
extern NSString*		BWRegistrationCompanyKey;
extern NSString*		BWRegistrationNumberKey;

@interface NSObject(BWRegistrationManagerDelegate)

- (BOOL)registrationManager:(BWRegistrationManager*)manager infoIsValid:(NSDictionary*)info;
- (NSString*)registrationManager:(BWRegistrationManager*)manager messageForValidInfo:(BOOL)validInfo;
- (void)registrationManagerPurchase:(BWRegistrationManager*)manager;
- (void)registrationManagerDidChangeValidState:(BWRegistrationManager*)manager;
- (void)registrationManagerDidDismiss:(BWRegistrationManager*)manager;

@end