//
//  BWTableView.h
//  UberProject
//
//  Created by Brian Webster on Wed Apr 09 2003.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface BWTableView : NSTableView 
{
	BOOL			shouldEditAfterReturn;
	BOOL			shouldDrawStripes;
	BOOL			handledKeyEvent;
	NSDictionary*	columnInfo;
	NSArray*		defaultIdentifiers;
	NSString*		message;
	
	NSTimeInterval	springLoadInterval;
	int				currentDragRow;
	NSTimer*		springLoadTimer;
}

- (void)loadColumnsFile:(NSString*)filePath;
- (BOOL)shouldEditAfterReturn;
- (void)setShouldEditAfterReturn:(BOOL)flag;
- (BOOL)shouldDrawStripes;
- (void)setShouldDrawStripes:(BOOL)flag;
- (NSString*)message;
- (void)setMessage:(NSString*)newMessage;
- (NSTimeInterval)springLoadInterval;
- (void)setSpringLoadInterval:(NSTimeInterval)newSpringLoadInterval;
- (int)currentDragRow;
- (void)setCurrentDragRow:(int)newCurrentDragRow;

@end

@interface NSObject(BWTableViewDelegate)

- (NSMenu*)tableView:(NSTableView*)tableView contextMenuForRows:(NSArray*)rows;

@end

extern NSString*		BWTableViewWillSpringNotification;