//
//  NSTableView-BWAdditions.h
//  UberProject
//
//  Created by Brian Webster on Thu Apr 10 2003.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface NSTableView(BWAppKit)

- (NSTableColumn*)tableColumnAtIndex:(unsigned)index;
- (NSDictionary*)tableColumnWidths;
- (void)setTableColumnWidths:(NSDictionary*)widths;
- (void)endEditingIfNecessary;
- (void)abortEditingIfNecessary;

- (void)setNeedsDisplayInColumn:(int)column;
- (void)setNeedsDisplayInRow:(int)row;
- (void)setNeedsDisplayInColumns:(NSRange)range;
- (void)setNeedsDisplayInRows:(NSRange)range;
- (void)setNeedsDisplayAroundRow:(int)row;

- (void)drawStripesInRect:(NSRect)clipRect;
- (void)selectRows:(NSArray*)rows;

- (void)initializeColumnChooser;
- (void)refreshColumnChooser;
- (void)loadColumns:(NSArray*)columnDictionaries;
- (void)loadColumnConfiguration;
- (NSArray*)columnConfiguration;
- (void)saveColumnConfiguration;
- (void)toggleColumnVisible:(id)sender;
- (NSTableColumn*)newTableColumnWithInfo:(NSDictionary*)columnDictionary;

- (NSArray*)allowedColumnIdentifiers;
- (NSArray*)defaultColumnIdentifiers;
- (NSDictionary*)tableColumnInfoForIdentifier:(NSString*)identifier;
- (NSTableColumn*)newTableColumnWithIdentifier:(NSString*)identifier;
- (id)bindingObjectForIdentifier:(NSString*)identifier value:(NSString*)value;

@end

@interface NSObject(BWAdditionsTableDelegate)

- (NSColor*)tableView:(NSTableView*)tableView backgroundColorForRow:(int)row;

@end

@interface NSObject(TableViewColumnConfigDelegate)

- (NSArray*)tableViewAllowedColumnIdentifiers:(NSTableView*)tableView;
- (NSArray*)tableViewDefaultColumnIdentifiers:(NSTableView*)tableView;

- (NSDictionary*)tableView:(NSTableView*)tableView columnInfoForIdentifier:(NSString*)identifier;
- (BOOL)tableView:(NSTableView*)tableView shouldEnableChoiceForColumnIdentifier:(NSString*)identifier;
- (NSString*)tableViewColumnConfigurationName:(NSTableView*)tableView;
- (id)tableView:(NSTableView*)tableView bindingObjectForIdentifier:(NSString*)identifier value:(NSString*)value;
- (void)tableView:(NSTableView*)tableView willRemoveColumnWithIdentifier:(NSString*)identifier;
- (void)tableView:(NSTableView*)tableView willAddTableColumn:(NSTableColumn*)tableColumn;

@end
