//
//  BWFoundationFunctions.h
//  UberProject
//
//  Created by Brian Webster on Sat May 03 2003.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class BWVersionNumber;

extern BOOL BWRangeContainsRange(NSRange bigRange, NSRange smallRange);
extern NSRect BWFitCenteredRect(NSSize size, NSRect boundingRect);
extern NSPoint BWCenterOfRect(NSRect rect);
extern NSString *BWLocalizedString(NSString *format, NSString *comment, ...);
extern NSArray *BWSearchPathForDirectoriesInDomains(NSSearchPathDirectory directory, NSSearchPathDomainMask domainMask, BOOL expandTilde, NSString* subFolderPath);
NSString *BWApplicationSupportSubPath();
BWVersionNumber *BWSystemVersionNumber();

void BWDebugLog(NSString* key, NSString* format, ...);
void BWDebugLogSystemProfile();
BOOL BWIsDebugEnabled(NSString* key);
void BWSetDebugEnabled(NSString* key, BOOL enabled);
void BWDebugClose();

#define SIMPLE_OBSERVE(aSelector, aName) \
	[[NSNotificationCenter defaultCenter] addObserver:self \
		selector:(aSelector) \
		name:aName \
		object:nil]
		
#define COMPARE(a, b) \
	((a) < (b) ? NSOrderedAscending : \
	((a) > (b) ? NSOrderedDescending : NSOrderedSame))
	
#define DISPOSE_TIMER(timer) \
	[(timer) invalidate]; \
	[(timer) release]; \
	(timer) = nil;

#define EQUAL_OBJECTS(a, b) \
	(((a) == (b)) || [(a) isEqual:(b)])
