//
//  BWIndexMap.h
//  Vocablulator
//
//  Created by bwebster on Fri Jan 19 2001.
//  Copyright (c) 2000 __CompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface BWIndexMap : NSObject 
{
	int count, *indices;
}

+ (BWIndexMap*)mapToMoveIndices:(NSArray*)indices toIndex:(int)index count:(int)count;
+ (BWIndexMap*)identityMapWithCount:(int)numIndices;
- (id)initWithIndicesNoCopy:(int*)indices count:(int)count;
- (id)initWithIndices:(const int*)indices count:(int)count;
- (id)initWithIndices:(NSArray*)indices;
- (unsigned)count;
- (const int*)indices;
- (int)indexForIndex:(int)index;
- (BWIndexMap*)inverseMap;
- (BWIndexMap*)reverseMap;
- (NSArray*)translateIndices:(NSArray*)indexArray;
- (BWIndexMap*)mapByApplyingMap:(BWIndexMap*)otherMap;

@end

@interface NSArray(BWIndexMap)

- (NSArray*)arrayUsingMap:(BWIndexMap*)map;
- (NSMutableArray*)mutableArrayUsingMap:(BWIndexMap*)map;
- (BWIndexMap*)sortMapUsingSelector:(SEL)selector;
- (BWIndexMap*)sortMapUsingSelector:(SEL)selector withObject:(id)object;

@end

@interface NSMutableArray(BWIndexMap)

- (void)reorderUsingMap:(BWIndexMap*)map;
- (void)sortUsingSelector:(SEL)selector withObject:(id)object;
- (BWIndexMap*)mapFromSortingUsingSelector:(SEL)selector;
- (BWIndexMap*)mapFromSortingUsingSelector:(SEL)selector withObject:(id)object;

@end