//
//  BWKeyPathArray.h
//  UberProject
//
//  Created by Brian Webster on Mon Aug 02 2004.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//
//  This is a lazy-fetching array that gets its objects by using key-value coding
//  to fetch values from the objects of another array.  This is useful when wanting
//  to do efficient searching of an array by one of the attributes of its objects.

#import <Cocoa/Cocoa.h>


@interface BWKeyPathArray : NSArray
{
	NSArray*			array;
	NSString*			keyPath;
}

- (id)initWithArray:(NSArray*)inArray keyPath:(NSString*)inKeyPath;

@end

@interface NSArray(BWKeyPathArray)

- (NSArray*)arrayForKeyPath:(NSString*)inKeyPath;

@end