//
//  BWPathIndexer.h
//  UberProject
//
//  Created by Brian Webster on Mon Mar 22 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//
//  This purpose of this class is to generate unique prefixes for a given set of paths.
//  This is the sort of thing that goes on in NSDocument's standard recent items menu.
//  If there are more than one file in a list with the same filename, it also includes
//  the enclosing folder, along with any parent folders up until the two paths differ.

#import <Foundation/Foundation.h>

@interface BWPathIndexer : NSObject 
{
	NSMutableDictionary*		pathsByFilename;
}

- (void)addPath:(NSString*)path;
- (void)removePath:(NSString*)path;
- (NSString*)prefixForPath:(NSString*)path;
- (BOOL)containsPath:(NSString*)path;

@end
