//
//  BWSelectorFormatter.h
//  UberProject
//
//  Created by Brian Webster on Fri May 23 2003.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//
//	The BWSelectorFormatter class translates an object to a string by calling a specified
//	selector with the object to be formatted as the receiver of the message.

#import <Cocoa/Cocoa.h>


@interface BWSelectorFormatter : NSFormatter <NSCopying>
{
	SEL				formatSelector;
	NSFormatter*	formatter;
}

- (id)initWithFormatSelector:(SEL)inFormatSelector;
- (id)initWithFormatSelector:(SEL)inFormatSelector formatter:(NSFormatter*)inFormatter;

- (SEL)formatSelector;
- (void)setFormatSelector:(SEL)newFormatSelector;
- (NSFormatter *)formatter;
- (void)setFormatter:(NSFormatter *)newFormatter;

@end
