//
//  NSArray-BWAdditions.h
//  UberProject
//
//  Created by Brian Webster on Thu Apr 03 2003.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface NSArray(BWFoundation) 

+ (NSArray*)arrayWithDelimitedText:(NSString*)text objectDelimiter:(NSString*)objectDelimiter fieldDelimiter:(NSString*)fieldDelimiter keys:(NSArray*)keys objectClass:(Class)objectClass;
- (id)deepCopy;
- (id)copyMutableContainers;
- (NSArray*)arrayByFilteringWithSelector:(SEL)selector;
- (NSArray*)arrayByFilteringWithSelector:(SEL)selector object:(id)object;
- (NSArray*)arrayByFilteringWithSelector:(SEL)selector object:(id)object matching:(BOOL)flag;

- (NSArray*)arrayByPerformingSelector:(SEL)selector;
- (NSArray*)arrayByPerformingSelector:(SEL)selector object:(id)inObject;
- (NSArray*)arrayByPerformingSelector:(SEL)selector object:(id)inObject nilPlaceholder:(id)nilPlaceholder;

- (NSArray*)objectAsArray;
- (id)firstObject;
- (NSArray*)reversedArray;
- (NSArray*)arrayByRemovingObject:(id)object;
- (unsigned)indexOfObject:(id)anObject inArraySortedUsingSelector:(SEL)selector;
- (NSArray*)allObjects;
- (unsigned)insertionIndexForObject:(id)object sortedUsingSelector:(SEL)selector;
- (unsigned)indexOfObjectMatchingValue:(id)value forKey:(NSString*)key;
- (id)objectMatchingValue:(id)value forKey:(NSString*)key;
- (NSArray*)arrayWithObjectsAtIndexes:(NSArray*)indexes;
- (NSArray*)arrayByMatchingValue:(id)value forKeyPath:(NSString*)keyPath;

@end
