//
//  NSFileManager-BWAdditions.h
//  UberProject
//
//  Created by Brian Webster on Thu Apr 03 2003.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <sys/attr.h>
#import <sys/vnode.h>

typedef enum
	{
	kBWRecursionNone		= 0,		//Don't go into subdirectories
	kBWRecursionPrefix		= 1,		//Handle the directory first, then its contents
	kBWRecursionPostfix		= 2			//Handle the contents first, then the directory
	} BWRecursionType;

@interface NSFileManager(BWFoundation) 

- (NSString*)displayPathForPath:(NSString*)path;
- (NSString*)uniqueFilePathForName:(NSString*)filename inDirectory:(NSString*)directory;
- (NSArray*)changeFileAttributes:(NSDictionary*)fileAttributes directoryAttributes:(NSDictionary*)directoryAttributes inDirectory:(NSString*)rootDirectory handler:(id)handler;
- (BOOL)createDirectoryAtPath:(NSString*)path attributes:(NSDictionary*)attributes createParents:(BOOL)createParents;
- (NSArray*)pathsOfDirectoryContentsAtPath:(NSString*)path;
- (NSString*)volumeMountPathForFilePath:(NSString*)path;
- (NSDictionary*)volumeAttributesForPath:(NSString*)path;
- (NSError*)iterateDirectory:(NSString*)directoryPath recursively:(BOOL)recursively target:(id)target selector:(SEL)selector withObject:(id)object;
- (NSError*)iterateDirectory:(NSString*)directoryPath recursionType:(BWRecursionType)recursionType target:(id)target selector:(SEL)selector withObject:(id)object;
- (unsigned long long)totalSizeOfFileAtPath:(NSString*)inPath;
- (unsigned long long)physicalSizeOfFileAtPath:(NSString*)inPath;
- (BOOL)isDirectoryAtPath:(NSString*)inPath;
- (BOOL)isDirectoryAtPath:(NSString*)inPath traverseLink:(BOOL)traverseLink;
- (fsobj_type_t)objectTypeAtPath:(NSString*)inPath;
- (fsobj_type_t)objectTypeAtPath:(NSString*)inPath traverseLink:(BOOL)traverseLink;
- (NSError*)copyPath:(NSString*)sourcePath toPath:(NSString*)destinationPath onlyIfNewer:(BOOL)onlyIfNewer;

@end

@interface NSObject(BWFileManagerHandler)

- (void)fileManager:(NSFileManager*)fileManager willChangePath:(NSString*)path percentComplete:(float)percentComplete;

@end

extern NSString*		BWVolumeMountPath;
extern NSString*		BWVolumeName;
extern NSString*		BWVolumeCreationDate;
