//
//  NSString-BWAdditions.h
//  UberProject
//
//  Created by Brian Webster on Thu Apr 03 2003.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

typedef enum _SearchKind
{
	kSearchStartsWith = 0,
	kSearchEndsWith,
	kSearchContains,
	kSearchDoesntContain,
	kSearchWholeWords,
	kSearchEntireKey
} BWSearchKind;

@interface NSString(BWFoundation) 

+ (NSString*)horizontalEllipsisString;
+ (NSString*)longDashString;
+ (NSString*)commandSymbolString;
+ (NSString*)stringWithStrings:(NSArray*)strings;
+ (NSString*)stringWithStrings:(NSArray*)strings separator:(NSString*)separator;
+ (NSString*)stringWithCharacter:(unichar)character;
+ (NSString*)UUIDString;

- (id)initWithStrings:(NSArray*)strings;
- (id)initWithStrings:(NSArray*)strings separator:(NSString*)separator;

- (id)initHexStringWithBytes:(const char*)bytes length:(unsigned)numBytes;
- (id)initHexStringWithBytes:(const char*)bytes length:(unsigned)numBytes padInterval:(int)padBytes prepend0x:(BOOL)prepend;
- (NSData*)hexStringData;
- (NSData*)hexStringDataWithPadding:(BOOL)pad;

- (NSString*)stringByPrependingString:(NSString*)string;

- (NSString*)POSIXPathFromCarbonPath;
- (NSString*)carbonPathFromPOSIXPath;
- (NSString*)stringByAppendingStringBeforePathExtension:(NSString*)appendString;
- (NSString*)stringByPrependingPathComponent:(NSString*)prependString;
- (BOOL)hasPathExtension:(NSString*)extension;
- (BOOL)containsPath:(NSString*)path;

- (NSArray*)stringsBySeparatingAtCharactersInSet:(NSCharacterSet*)characterSet;
- (NSString*)substringUpToString:(NSString*)separator remainingString:(NSString**)outRemainingString;

- (BOOL)boolValue;
- (NSRange)fullRange;
- (unsigned)unsignedIntValue;
- (long long)longLongValue;
- (NSString*)lowercaseFirst;
- (NSString*)uppercaseFirst;
- (FourCharCode)fourCharCode;

- (unsigned)numberOfLines;
- (NSRange)rangeForLineNumber:(unsigned)lineNumber;

- (NSComparisonResult)numericCaseInsensitiveCompare:(NSString*)string;
- (NSRange)rangeOfString:(NSString*)string options:(int)options range:(NSRange)searchRange searchKind:(BWSearchKind)searchKind;

@end
