//
//  AUAppleEvent.h
//  SpeakableFinder
//
//  Created by root on Mon Oct 02 2000.
//  Copyright (c) 2000 __CompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "AUDescriptor.h"

@class AUAddress;
@class AUObjectSpecifier;
@class AUType;

@interface AUAppleEvent : AUDescriptor
{

}

+ (AUAppleEvent*)getDataEventToApp:(AUAddress*)address withObject:(AUDescriptor*)desc desiredType:(AUType*)type;
+ (AUAppleEvent*)getDataEventToApp:(AUAddress*)address withObject:(AUDescriptor*)desc;
+ (AUAppleEvent*)setDataEventToApp:(AUAddress*)address withObject:(AUObjectSpecifier*)object data:(AUDescriptor*)valueDescriptor;
+ (AUAppleEvent*)countEventToApp:(AUAddress*)address withObject:(AUObjectSpecifier*)object classToCount:(DescType)classToCount;
+ (void)cancelEventWithReturnID:(AEReturnID)returnID;
- (id)initWithEventClass:(AEEventClass)theClass eventID:(AEEventID)eventID targetAddress:(AUAddress*)address;
- (AUAppleEvent*)send;
- (AUAppleEvent*)sendWithMode:(AESendMode)sendMode priority:(AESendPriority)priority timeout:(long)timeout;
- (void)sendNoReply;
- (AEReturnID)sendAsyncWithDelegate:(id)delegate selector:(SEL)selector;
- (void)setParameter:(AUDescriptor*)descriptor forKeyword:(AEKeyword)keyword;
- (AUDescriptor*)reply;
- (OSStatus)replyErr;
- (NSString*)replyErrorString;
- (NSError*)replyError;
- (AUDescriptor*)parameterForKeyword:(AEKeyword)keyword;
- (void)setAttribute:(AUDescriptor*)descriptor forKeyword:(AEKeyword)keyword;
- (AUDescriptor*)attributeForKeyword:(AEKeyword)keyword;
- (AUDescriptor*)directObject;

@end

@interface AUDescriptor(AUAppleEvent)

- (AUAppleEvent*)coerceToAppleEvent;

@end