//
//  AUDescriptor.h
//  SpeakableFinder
//
//  Created by root on Mon Oct 02 2000.
//  Copyright (c) 2000 __CompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <Carbon/Carbon.h>

#ifndef AUAssert
#define AUAssert(err, func) NSAssert2(err == noErr, @"%@ returned error code %d", func, err);
#endif

@interface AUDescriptor : NSObject 
{
	AEDesc descriptor;
}

+ (void)registerClass:(Class)aClass forDescriptorType:(DescType)descType;
+ (Class)classForDescriptorType:(DescType)descType;
+ (AUDescriptor*)descriptorWithAEDesc:(AEDesc)desc;
+ (AUDescriptor*)descriptorWithNSDescriptor:(NSAppleEventDescriptor*)inDescriptor;
+ (AUDescriptor*)nullDescriptor;
+ (AUDescriptor*)descriptorWithType:(DescType)descType bytes:(const void*)bytes length:(unsigned)length;
+ (AUDescriptor*)descriptorWithType:(DescType)descType fourCharCode:(FourCharCode)fourCharCode;

- (id)initWithDescriptorType:(DescType)descType data:(NSData*)data;
- (id)initWithDescriptorType:(DescType)descType bytes:(const void*)bytes length:(unsigned)length;
- (id)initWithAEDesc:(AEDesc)aDesc;
- (id)initWithNSDescriptor:(NSAppleEventDescriptor*)inDescriptor;

- (NSString*)defaultDescription;

- (AEDesc)descriptor;
- (DescType)descriptorType;
- (NSData*)data;
- (unsigned)dataSize;
- (void)getBytes:(void*)buffer;
- (void)getBytes:(void*)buffer length:(unsigned)length;

- (NSString*)typeString;
- (NSString*)dataDescription;
- (AUDescriptor*)coerceToDescriptorType:(DescType)descType;
- (id)propertyListValue;
- (id)objectValue;

@end

@interface NSObject(AUDescriptor)

- (AUDescriptor*)convertToDescriptor;

@end