//
//  AUList.h
//  SpeakableFinder
//
//  Created by root on Mon Oct 02 2000.
//  Copyright (c) 2000 __CompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "AUDescriptor.h"

@interface AUList : AUDescriptor 
{
	NSMutableArray *descriptors;
}

+ (AUList*)listWithDescriptor:(AUDescriptor*)aDescriptor;
+ (AUList*)listWithDescriptors:(NSArray*)descriptorArray;
- (id)initWithCapacity:(unsigned)initialCapacity;
- (id)initWithDescriptor:(AUDescriptor*)aDescriptor;
- (id)initWithDescriptors:(NSArray*)descriptors;
- (int)descriptorCount;
- (AUDescriptor*)descriptorAtIndex:(int)index;
- (void)insertDescriptor:(AUDescriptor*)newDescriptor atIndex:(int)index;
- (void)addDescriptor:(AUDescriptor*)aDescriptor;
- (void)addDescriptorsFromList:(AUList*)inList;
- (void)removeDescriptorAtIndex:(int)index;
- (NSArray*)allDescriptors;
- (AUList*)sublistWithRange:(NSRange)range;
- (NSEnumerator*)objectEnumerator;

@end

@interface AUDescriptor(AUList)

- (AUList*)coerceToList;

@end

@interface NSArray(AUList)

- (AUDescriptor*)convertToDescriptor;

@end