//
//  AUNumber.h
//  UberProject
//
//  Created by Brian Webster on Thu Dec 04 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "AUDescriptor.h"

@interface AUNumber : AUDescriptor 
{
	NSNumber*			numberValue;
}

+ (AUNumber *)numberDescWithShort:(short)value;
+ (AUNumber *)numberDescWithInt:(int)value;
+ (AUNumber *)numberDescWithUnsignedInt:(unsigned int)value;
+ (AUNumber *)numberDescWithLong:(long)value;
+ (AUNumber *)numberDescWithUnsignedLong:(unsigned long)value;
+ (AUNumber *)numberDescWithLongLong:(long long)value;
+ (AUNumber *)numberDescWithFloat:(float)value;
+ (AUNumber *)numberDescWithDouble:(double)value;

- (id)initWithNumber:(NSNumber*)inNumber;
- (NSNumber*)numberValue;

- (short)shortValue;
- (int)intValue;
- (unsigned int)unsignedIntValue;
- (long)longValue;
- (unsigned long)unsignedLongValue;
- (long long)longLongValue;
- (unsigned long long)unsignedLongLongValue;
- (float)floatValue;
- (double)doubleValue;

- (NSString *)stringValue;

@end

@interface AUDescriptor(AUNumber)

- (AUNumber*)coerceToShort;
- (AUNumber*)coerceToLong;
- (AUNumber*)coerceToUnsignedLong;
- (AUNumber*)coerceToLongLong;
- (AUNumber*)coerceToFloat;
- (AUNumber*)coerceToDouble;

@end

@interface NSNumber(AUNumber)

- (AUDescriptor*)convertToDescriptor;

@end