//
//  AUObjectSpecifier.h
//  SpeakableFinder
//
//  Created by root on Mon Oct 02 2000.
//  Copyright (c) 2000 __CompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "AUDescriptor.h"

@class AUType;
@class AUAddress;

@interface AUObjectSpecifier : AUDescriptor 
{
	AUObjectSpecifier *container;
}

+ (AUObjectSpecifier*)propertySpecifierWithContainer:(AUObjectSpecifier*)containerSpecifier property:(FourCharCode)property;
+ (AUObjectSpecifier*)ordinalSpecifierWithContainer:(AUObjectSpecifier*)containerSpecifier objectClass:(OSType)aClass ordinal:(OSType)ordinal;
+ (AUObjectSpecifier*)testSpecifierWithContainer:(AUObjectSpecifier*)containerSpecifier objectClass:(OSType)aClass testDescriptor:(AUDescriptor*)testDescriptor;

- (id)initExaminationSpecifierWithObjectClass:(FourCharCode)objectClass keyForm:(FourCharCode)keyForm keyData:(AUDescriptor*)keyData;
- (id)initWithObjectClass:(FourCharCode)objectClass container:(AUObjectSpecifier*)objectContainer keyForm:(FourCharCode)keyForm keyData:(AUDescriptor*)keyData;
- (id)initWithObjectClass:(FourCharCode)objectClass containerDescriptor:(AUDescriptor*)objectContainer keyForm:(FourCharCode)keyForm keyData:(AUDescriptor*)keyData;
- (AUObjectSpecifier*)container;
- (FourCharCode)objectClass;
- (FourCharCode)keyForm;
- (AUDescriptor*)keyData;
- (AUObjectSpecifier*)specifierForProperty:(AUType*)propertyType;
- (AUObjectSpecifier*)specifierForElementType:(AUType*)elementType keyForm:(AEKeyword)keyForm keyData:(AUDescriptor*)keyData;
- (AUDescriptor*)retrieveDataFromApp:(AUAddress*)address asType:(AUType*)type;
- (AUDescriptor*)retrieveDataFromApp:(AUAddress*)address;

@end

@interface AUDescriptor(AUObjectSpecifier)

- (AUObjectSpecifier*)coerceToObjectSpecifier;

@end