//
//  CUAlias.h
//  ScriptServices
//
//  Created by bwebster on Thu Oct 18 2001.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <Carbon/Carbon.h>

@interface CUAlias : NSObject <NSCopying>
{
	AliasHandle aliasHandle;
	BOOL disposeOnDealloc;
}

+ (BOOL)isAliasFileFromPath:(NSString*)path;
+ (NSString*)pathFromAliasFile:(NSString*)path withMount:(BOOL)doMount;
+ (CUAlias*)aliasWithPath:(NSString*)path;
- (id)initWithFSRef:(FSRef*)ref;
- (id)initWithFSRef:(FSRef*)ref relativeToFSRef:(FSRef*)baseRef;
- (id)initWithPath:(NSString*)path;
- (id)initWithPath:(NSString*)path relativeToPath:(NSString*)basePath;
- (id)initWithData:(NSData*)data;
- (id)initWithAliasHandle:(AliasHandle)handle;
- (id)initWithAliasHandle:(AliasHandle)handle disposeOnDealloc:(BOOL)disposeOnDealloc;
- (NSString*)resolveAlias;
- (NSString*)resolveAliasWithMountFlags:(unsigned long)mountFlags;
- (NSString*)resolveAliasRelativeToPath:(NSString*)path;
- (NSString*)resolveAliasRelativeToPath:(NSString*)path wasChanged:(BOOL*)wasChanged;
- (NSString*)resolveAliasRelativeToPath:(NSString*)path wasChanged:(BOOL*)wasChanged mountFlags:(unsigned long)mountFlags;
- (NSArray*)allPaths;
- (NSData*)aliasData;
- (NSError*)writeToPath:(NSString*)path;

- (NSError*)writeToPath:(NSString*)path;

@end
