//
//  CUFunctions.h
//  UberProject
//
//  Created by Brian Webster on Tue May 20 2003.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <Carbon/Carbon.h>

@class BWVersionNumber;

extern NSString * const CUCarbonException;
extern NSString * const CUExceptionErrorCode;
extern NSString * const CUExceptionFunctionName;

extern BOOL CUFSSpecFromPath(NSString *path, FSSpec *spec);
extern NSString *CUPathFromFSSpec(FSSpec *spec);
extern BOOL CUFSRefFromPath(NSString *path, FSRef *ref);
extern NSString *CUPathFromFSRef(FSRef *ref);
NSString *CUFindFolder(short domain, OSType folderType, BOOL createFolder);

extern NSFontTraitMask CUFontTraitMaskForStyleField(StyleField styleField);
extern StyleField CUStyleFieldForFontTraitMask(NSFontTraitMask mask);
extern int CUStyleScrapDataSize(StScrpPtr scrap);

BWVersionNumber *CUSystemVersionNumber();

#ifndef CUAssert
#define CUAssert(err, functionName) \
{ \
	if(err != noErr) \
	{ \
		NSDictionary *userInfo = [NSDictionary dictionaryWithObjectsAndKeys:[NSNumber numberWithInt:err], CUExceptionErrorCode, functionName, CUExceptionFunctionName, nil]; \
		NSString *reason; \
 \
		NSException *exception; \
		reason = [NSString stringWithFormat:@"Carbon function %@ returned error %d"]; \
		exception = [NSException exceptionWithName:CUCarbonException reason:reason userInfo:userInfo]; \
		[exception raise]; \
	} \
}
#endif
