//
//  CUProcess.h
//  ScriptServices
//
//  Created by bwebster on Mon Oct 01 2001.
//  Copyright (c) 2001 Brian Webster. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <Carbon/Carbon.h>

@class AUAddress;

@interface CUProcess : NSObject 
{
	NSString*					name;
	NSString*					path;
	ProcessSerialNumber			processSerialNumber;
	ProcessSerialNumber			launcherSerialNumber;
	OSType						signature;
	CUProcess*					launcher;
}

+ (CUProcess*)currentProcess;
+ (CUProcess*)frontProcess;
+ (NSArray*)allProcesses;
+ (CUProcess*)processForSerialNumber:(ProcessSerialNumber)serialNumber;
+ (CUProcess*)processWithName:(NSString*)processName;
+ (CUProcess*)processWithSignature:(OSType)sig;
- (id)initWithInfoRec:(ProcessInfoExtendedRecPtr)info;
- (NSString*)name;
- (ProcessSerialNumber)processSerialNumber;
- (CUProcess*)launcher;
- (BOOL)isRunning;
- (NSString*)path;
- (OSType)signature;
- (AUAddress*)address;
- (void)activate;
- (NSError*)quit;

@end
