//
//  CUResource.h
//  ScriptServices
//
//  Created by bwebster on Thu Sep 20 2001.
//  Copyright (c) 2001 Brian Webster. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class CUHandleData, CUResourceFile;

@interface CUResource : NSObject 
{
	CUResourceFile *resourceFile;
	CUHandleData *resourceData;
	short resourceID;
	ResType resourceType;
	NSString *resourceName;
	BOOL updateDataOnDealloc, isValid;
}

- (id)initWithResourceFile:(CUResourceFile*)resFile index:(int)index type:(ResType)type;
- (id)initWithResourceFile:(CUResourceFile*)resFile ID:(int)resID type:(ResType)type;
- (id)initWithResourceFile:(CUResourceFile*)resFile handle:(Handle)handle;

- (short)resourceID;
- (void)setResourceID:(short)newID;
- (ResType)resourceType;
- (NSString*)resourceName;
- (void)setResourceName:(NSString*)newName;
- (NSMutableData*)resourceData;

- (void)revertResource;
- (BOOL)resourceChanged;
- (void)markResourceChanged;

- (BOOL)updateDataOnDealloc;
- (void)setUpdateDataOnDealloc:(BOOL)flag;
- (BOOL)isValid;
- (void)setValid:(BOOL)flag;

- (CUResourceFile*)resourceFile;

@end
