//
//  CUResourceFile.h
//  ScriptServices
//
//  Created by bwebster on Mon Sep 17 2001.
//  Copyright (c) 2001 Brian Webster. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <Carbon/Carbon.h>

@class CUResource;

@interface CUResourceFile : NSObject 
{
	NSString *path;
	FSSpec spec;
	BOOL isOpen;
	short refNum;
	NSMutableDictionary *resources;
}

+ (void)pushResFile:(short)newResFile;
+ (void)popResFile;
- (id)initWithPath:(NSString*)path;
- (id)initWithPath:(NSString*)path create:(BOOL)createResFile;
- (id)initWithPath:(NSString*)path open:(BOOL)openResFile;
- (id)initWithPath:(NSString*)path create:(BOOL)createResFile open:(BOOL)openResFile;
- (NSString*)path;
- (BOOL)isOpen;
- (BOOL)openResFile;
- (void)closeResFile;
- (CUResource*)createResourceOfType:(ResType)type name:(NSString*)name data:(NSData*)data;
- (CUResource*)createResourceWithID:(short)resID type:(ResType)type name:(NSString*)name data:(NSData*)data;
- (CUResource*)resourceAtIndex:(int)index ofType:(ResType)type;
- (CUResource*)resourceForID:(short)resID ofType:(ResType)type;
- (int)numResourcesOfType:(ResType)type;
- (ResType)typeAtIndex:(int)index;
- (int)numTypes;
- (void)releaseResource:(CUResource*)resource;
- (void)updateResourceFile;

@end

@interface CUResourceKey : NSObject <NSCopying>
{
	short resID;
	ResType resType;
}

+ (CUResourceKey*)keyWithID:(short)ID type:(ResType)type;
- (id)initWithID:(short)ID type:(ResType)type;
- (short)resourceID;
- (ResType)resourceType;

@end

