//
//  CUScript.h
//  ScriptServices
//
//  Created by bwebster on Sun Sep 16 2001.
//  Copyright (c) 2001 Brian Webster. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <Carbon/Carbon.h>

@class AUDescriptor, AUAppleEvent, AUList;

extern NSString * const CUScriptException;
extern NSString * const CUScriptErrorMessage;

@interface CUScript : NSObject 
{
	OSAID scriptID;
	NSData *scriptData;
}

+ (BOOL)isScriptFileAtPath:(NSString*)path;
+ (CUScript*)scriptFromFile:(NSString*)path;
- (id)initWithOSAID:(OSAID)ID;
- (id)initWithScriptData:(NSData*)data;
- (ComponentInstance)scriptingComponent;
- (NSData*)scriptData;
- (NSArray*)handlerNames;
- (CUScript*)handlerForName:(AUDescriptor*)handlerName;
- (NSAttributedString*)scriptSource;
- (BOOL)canGetSource;
- (NSString*)scriptError;

- (AUDescriptor*)coerceToDescriptor;
- (AUDescriptor*)coerceToDescriptorType:(DescType)descType;
- (CUScript*)execute;
- (AUDescriptor*)executeWithDescriptor:(AUDescriptor*)directObject;
- (CUScript*)executeEvent:(AUAppleEvent*)event;
- (AUAppleEvent*)doEvent:(AUAppleEvent*)event;

@end
